




























                   DAILY SOLAR GEOPHYSICAL DATA BROADCAST PROCESSOR

                           DATABASE MANAGER - USERS MANUAL







                                     Version 1.01









                                (c) Copyright 1992 by

                            The Solar Terrestrial Dispatch













                                  Table Of Contents







          Introduction  . . . . . . . . . . . . . . . . . . . . . . . .   3

          The SGDB Data Sets  . . . . . . . . . . . . . . . . . . . . .   4

          Registering BCAST . . . . . . . . . . . . . . . . . . . . . .   4

          Starting Up BCAST . . . . . . . . . . . . . . . . . . . . . .   5

          The Configuration File  . . . . . . . . . . . . . . . . . . .   5

          The BCAST Environment Variable  . . . . . . . . . . . . . . .   6

          Processing Data Sets  . . . . . . . . . . . . . . . . . . . .   7

          Displaying Data Sets On-Screen  . . . . . . . . . . . . . . .   9

          The Archive and Analysis Menu . . . . . . . . . . . . . . . .   9
               Saving Loaded Data Sets to the Database  . . . . . . . .  10
               Loading a Dataset from the Database  . . . . . . . . . .  11
               The Graphical Analysis Options . . . . . . . . . . . . .  12
               Generating an Activity Summary Report  . . . . . . . . .  13
               Generating a Standard SGDB File & Modifying Records  . .  14
               Dumping Data Sets to an ASCII File . . . . . . . . . . .  15
               Deleting Data Sets from the Database . . . . . . . . . .  15
               Returning to the Main Menu . . . . . . . . . . . . . . .  16

          Exiting BCAST and Returning to DOS  . . . . . . . . . . . . .  16

          The Batch Processing Feature of BCAST . . . . . . . . . . . .  16

          Alternate Methods of Executing BCAST  . . . . . . . . . . . .  17






                                                                          3

          Introduction

               The Solar Terrestrial  Dispatch (STD)  has been providing  a
          comprehensive  set  of  daily solar  geophysical  indices  to the
          public in  the  form of  a  product  known as  the  "Daily  Solar
          Geophysical  Data  Broadcast"  (SGDB).    The  data  and  indices
          contained in the SGDB are very  valuable to persons interested in
          ionospheric   radio   communications,  solar   activity,  auroral
          activity,  and related  geomagnetic  events and  even atmospheric
          phenomena.  The data sets are being used by research institutions
          and astronomical organizations around the world.

               It was clearly  evident that such  a large dataset would  be
          more useful if  it could be archived  and studied over time.   To
          satisfy this  need, the STD  developed a  software package  which
          would automatically  extract all  of the relevant  data from  the
          SGDBs  and archive  them to disk  for analysis  and study.   This
          software  is  known  as  "BCAST",   the  Solar  Geophysical  Data
          BroadCAST Processor and Database Manager.

               BCAST provides  complete  archive  and  database  management
          facilities in  a user-friendly  and easily  operated environment.
          It  will  automatically maintain  a fully  sorted archive  of the
          datasets for instant recall or graphical  analysis.  It will also
          produce detailed summaries of the datasets in laymans terms which
          may be printed out and distributed, or filed away.

               BCAST also provides  a powerful batch processing  feature to
          automatically archive large numbers of SGDB reports in one simple
          step.  In addition,  a completely new full-screen file  selection
          facility has  been added to  simplify and enhance  the processing
          and selection of the datasets.

               Extensive and complete monthly archives  of all SGDB reports
          are available from the STD, through the STD BBS, or via anonymous
          FTP for those who are connected to the larger electronic networks
          such as the Internet.  Each of the monthly archives may  be batch
          processed or selectively processed using BCAST.

               The STD also supplies extensive  documentation to help those
          who are less  familiar, understand the  significance of the  data
          contained in the daily SGDB reports.  The document "Understanding
          Solar Terrestrial  Reports" comes  in two-parts and  is a  superb
          introductory text for those  who want to know more  regarding the
          relations between  solar  activity  and  Earth-based  terrestrial
          activity.  These documents  are also available from the  STD BBS,
          or through anonymous FTP.

               The STD BBS is accessible 24 hours a day, 7 days a week, and
          provides  alerts, warnings,  and  forecasts  regarding solar  and
          geophysical phenomena.  Forecasts of such things as major flares,
          auroral activity, geomagnetic  storms, etc, are available  on the






                                                                          4

          BBS.  The phone number to the BBS is: 403 756-3008.

               The database  generated and maintained by BCAST will let you
          analyze and study the cyclical behaviour  of such things as solar
          activity,  geomagnetic  activity,  and ionospheric  disturbances.
          You may also  be able to  anticipate the future behaviour  of the
          indices.    This is  invaluable to  those  who, for  example, are
          interested  in    predicting when  radio  communications  will be
          optimum, or when auroral activity may  again be observed, or when
          the next group of hot solar regions is due to rotate into view.
           

          The SGDB Data Sets

               The Solar Geophysical Data Broadcasts (SGDBs) released daily
          by the Solar  Terrestrial Dispatch  are composed of  a number  of
          compact textual lines.  In order to fully describe the meaning of
          each  component of each line in the SGDBs, a document was created
          which  goes  through the  data sets  line  by line,  component by
          component. 
           
               A complete copy of this descriptive document may be found in
          the file "SGDB.DOC".


          Registering BCAST

               BCAST is not  free.  A  considerable amount of our  time and
          resources have been  expended to  develop this software  package,
          not to mention the large number  of resources which are regularly
          dedicated to produce the daily data sets.
           
               In order to be  able to continue providing these  daily data
          sets and software to  use them, it  is important that we  recover
          our costs for providing  these services.  In order  to accomplish
          this,  we have  based the BCAST software  on the shareware  theme
          and will require  payment from those who  wish to use all  of its
          capabilities.

               The  BCAST  software   package  is  freely  distributed   as
          "Unregistered" software.  To purchase the  software so all of its
          features may  be used,  it must  be registered.  The only  way to
          accomplish this is  to send a  cheque or  money order for  $35.00
          dollars (in Canadian or U.S. funds) to:

                             Solar Terrestrial Dispatch
                             P.O. Box 357
                             Stirling, Alberta, Canada
                             T0K 2E0

               All  funds  should  be remitted  to  the  "Solar Terrestrial
          Dispatch".    U.S. cheques  or money  orders  are acceptable.   A






                                                                          5

          sample registration form is contained  with this software package
          under the  filename "REGISTER.DOC".  You may print out a copy and
          mail it to us with your payment, if desired. 
           
               Upon receipt of  your registration  request and payment,  we
          will immediately send you the necessary instructions to make your
          copy of the  BCAST software  a registered copy,  along with  your
          unique registration I.D. number.  Thereafter, you will be able to
          use the BCAST software without limitation. 
           
               If  you have an email address  on one of the larger INTERNET
          or BITNET  networks, include  your e-mail  address(es) with  your
          registration request so  we can contact  you through e-mail.   If
          you don't have  an e-mail address  or if you  fail to include  it
          with your payment, we will notify you through postal mail. 


          Starting Up BCAST

               There are two ways you can invoke BCAST.  The easiest method
          is simply to  type "BCAST" at your DOS command line prompt.  This
          will immediately load  the program  and execute it.   The  second
          method  of  invoking BCAST  is  through  the use  of  the "batch"
          feature  for  processing  multiple  SGDB  data sets  quickly  and
          easily.  This feature will be described later. 
           
               In  order for BCAST  to be able to  find the various support
          files it requires for normal  operation (ex. the database  file),
          you  should  execute  BCAST  in  the  directory  where  the BCAST
          database   file exists.   When  you are  maintaining a  database,
          BCAST  expects  to find  the  database  file with  the  filename:
          "DATASETS.DAT".  BCAST will not utilize the database if this file
          cannot be found in the same directory that you execute BCAST. 
           
               After you have  executed BCAST, a  title page should  appear
          on-screen.   If you have registered your  copy of BCAST, the word
          "Registered" will appear on the title page.  If you have  not yet
          registered your copy  of BCAST, the  word "Unregistered" will  be
          displayed.  Unregistered copies  of BCAST are heavily limited  in
          the  number of functions which may be performed, in order to help
          encourage payment for the program.
           
               Pressing any key will move you from the title page screen to
          the main menu screen.  This screen has four major functions which
          may be selected using the arrow keys.  Each function is discussed
          below. 


          The Configuration File

               Version 1.01 of  BCAST supports a simple  configuration file
          to help automate and customize program operation.  This file must






                                                                          6

          be located  in the same directory as BCAST.EXE.   The name of the
          configuration  file is  "BCAST.INI".  At  the present  time, this
          configuration  file supports  two commands:  MASK and  GRAPHSTEP.
          Each of these commands will be described below.

               The MASK command  is used by  BCAST to determine what  files
          will be  displayed when  selecting SGDB  files to  process.   For
          example,  the  daily  SGDB  reports  commonly have  the  filename
          extension ".dly"  (ex. 92-02-14.dly) to  distinguish SGDB reports
          from other files.  The default  MASK parameter "*.dly" will force
          BCAST  to  select only  those  files which  contain  the filename
          extension ".dly" from your disk.

               The MASK parameter  can also contain drive  and/or directory
          structure  information.    This  is  very  useful  if   you  have
          established a separate data  directory for the SGDB reports.   If
          for example,  your BCAST  software was  located in the  directory
          "C:\bcast"  and  your data  directory  storing  all of  the  SGDB
          reports was located  in "C:\bcast\daily", you could  inform BCAST
          to   use  the   data   directory   by   specifying  a   MASK   of
          "C:\bcast\daily\*.dly".  Thereafter, whenever you want to process
          another SGDB report,  all you would need to do is  run BCAST.  It
          would automatically select your data directory.

               The GRAPHSTEP configuration  command is associated  with new
          graphics  commands  imbedded  within  the   routines  which  draw
          graphical  charts of  the various  solar  geophysical quantities.
          Version 1.01 of BCAST permits  movement within the database  when
          displaying graphs  of data  on-screen.   Using  the PAGEDOWN  and
          PAGEUP  keys, you  can  move  forward  or  backward  through  the
          database  to graphically  view different  periods of  time.   The
          GRAPSTEP command determines how many days  forward or backward to
          advance when using PAGEDOWN or PAGEUP.  The default  given in the
          "BCAST.INI" configuration file is  35.  That is, BCAST  will move
          through the database +/-  35 days at a time.   This is equivalent
          to advancing by half a screen  forward or backward (one graphical
          chart on-screen can contain up to 70 days worth of data).


          The BCAST Environment Variable

               Version 1.01  supports  the definition  of  the  environment
          variable "BCAST".   This variable should contain the  location of
          the BCAST software.  Specifically, it  must contain the full path
          to the BCAST.EXE and BCAST.INI files.  For example, if your BCAST
          software  is  located  in  the  directory "C:\bcast",  then  your
          AUTOEXEC.BAT   file    should   contain    the   command:    "SET
          BCAST=C:\BCAST".

               Using this environment variable, you will be able to execute
          BCAST from any directory in your computer.  This was not possible
          with version 1.00 of BCAST.






                                                                          7



          Processing Data Sets

               This section of  BCAST was completely rewritten  for version
          1.01 in order to enhance and  simplify the processing of datasets
          by  BCAST.   It provides  a powerful interface  and will  let you
          selectively  process any number of  SGDB reports for inclusion in
          the database or for viewing on-screen.

               To process data sets from the main menu of BCAST, select the
          "Process Datasets" option.  A screen  will appear showing you the
          names of the files BCAST identified with the MASK parameter given
          in the configuration file.   If no files match, the statement "No
          Files Selected"  will appear  on the  bottom of  the screen.   If
          files are selected, they will  be sorted from left to right,  and
          top to bottom.  One screen can display up to 72 files at a  time.
          If  BCAST  identifies more  than 72  files,  it will  display the
          remaining files  on additional  screens after  you have  finished
          processing the desired files from the current screen.

               To select a file for processing, use the arrow  keys to move
          the screen cursor over the file you  wish to process.  Then press
          the SPACE-BAR.   The first file you select in this manner will be
          identified on-screen by  the appearance  of red "#01:"  preceding
          the filename.  The second file  you select will be prepended with
          a red "#02:" and so on.  You can select up to 72 files to process
          on-screen  in this manner.   Each  will be  numbered accordingly.
          The  importance  of  this  numbering  scheme  will  be  explained
          shortly.

               After  you  have finished  selecting  the files  to process,
          press  ENTER.   BCAST  will process  all  of the  files you  have
          selected  in the order  you selected them.   If any  of the files
          being processed are corrupt, BCAST will replace its corresponding
          number with "BAD:" so you can identify those files which may need
          to  be repaired  or  replaced.   If  all  goes  well, BCAST  will
          continue processing the files until all selected files have  been
          processed.

               After  all  of the  files  have been  processed,  BCAST will
          display the next screenful of files matching the  MASK parameter.
          If all of the files have been selected, BCAST will return  you to
          the main menu.

               Please note that registered copies of BCAST  will attempt to
          archive  all  selected  files  to  the  database.    During  this
          procedure, some files may process faster than others.  The reason
          for this  is due to the fact that  BCAST maintains a fully sorted
          database.   When it  attempts  to archive  a new  dataset to  the
          database, it re-sorts the database.  Therefore, if you process an
          SGDB report  that has a date near the  end of the database, BCAST






                                                                          8

          will process it relatively quickly since very little sorting will
          need to  be done.  On  the other hand,  if you process  a dataset
          that has an  old date,  BCAST may need  to re-sort a  significant
          fraction of the database.  The speed with which BCAST is  able to
          process files into  the sorted database  will also depend on  the
          size of the database.

               You need not worry about selecting or processing files which
          already exist in your database.   BCAST will not overwrite or add
          datasets to the database if they already exist.  If you happen to
          select and  process a  file which  is already  contained in  your
          database, BCAST will simply  skip over that file and  assume that
          it has already been processed.

               Knowing how  BCAST processes  selected files  enables us  to
          understand  why the numbering  scheme is important.   Since BCAST
          maintains a fully-sorted database, you can significantly speed up
          the  processing of large numbers of datasets if you try to select
          files in a sorted sequence.  For example, if you need  to process
          files dated 10,  11, and 12 February, you would  select the files
          so that the  first file selected is  for 10 February, the  second
          file  selected is for 11 February,  and the last file selected is
          for 12  February.   If you selected  these files  in the  reverse
          order, BCAST would have to sort the database unnecessarily.

               Unregistered copies of BCAST will not attempt to archive the
          selected files to  the database.  Instead,  unregistered software
          will only load  the selected files  for on-screen review.   It is
          important to remember  that in  both registered and  unregistered
          versions  of BCAST,  the last  file loaded  will be the  only one
          resident in memory for reviewing on-screen.

               To  deselect a  file  which you  have  already selected  for
          processing, simply move the cursor over top of the file you  want
          to deselect and press the SPACE-BAR.   The number associated with
          that selection will  be deallocated.   The rest of the  selection
          numbers will automatically be reassigned to remain contiguous.

               An additional feature which can  be accessed while selecting
          files  to  be  processed,  is  the  ability to  change  the  MASK
          parameter.   On the  bottom left-hand corner  of the screen  is a
          "Mask=" statement.   The current value  of the MASK parameter  is
          printed in this area.  If the length of the MASK parameter is too
          large to be fully printed on-screen, it will be  truncated at the
          appropriate location  and a  ~ symbol will  be appended.   The  ~
          symbol  informs you that  truncation was performed,  and that the
          entire MASK parameter cannot be printed on-screen.

               To change the  MASK parameter  while selecting files,  press
          the "M"  key (for Mask).  A  cursor will immediately appear after
          the  "Mask="  statement.   Simply  type  in your  new  path using
          whatever drive,  directory, and/or  wildcard information  that is






                                                                          9

          necessary.  When  finished, press  ENTER and the  screen will  be
          redrawn with the files that match the new MASK parameter.

               Changing the MASK  string from within BCAST  does not affect
          the value of the MASK given  in the configuration file BCAST.INI.
          Modifying the MASK value from within BCAST is only temporary.  As
          soon as you re-run BCAST, the MASK will once again be loaded with
          the value given in the configuration file.  If no MASK command is
          given within the configuration file,  the default string used for
          the MASK is "*.dly".

               You  may  exit the  file  selection  screen at  any  time by
          pressing the ESCape key.  This will immediately return you to the
          main menu, even if files were selected to be processed.


          Displaying Data Sets On-Screen

               After a SGDB dataset has been  loaded from disk into memory,
          you may  choose to  display the  data on-screen  in a  friendlier
          format.  The  second  main  menu  function,  "Display  Data  Set"
          provides  you with this capability. 
           
               This feature automatically decodes the various acronyms used
          in the textual SGDB reports and displays their meanings on-screen
          in laymans terms.  It provides screenful upon screenful of useful
          information regarding  the dataset  by interpreting the  contents
          and explaining or displaying them. 
           
               The first and possibly second screens displayed by BCAST are
          summaries of the  warnings and  alerts which were  active at  the
          time the  SGDB data  set was  compiled at  the Solar  Terrestrial
          Dispatch.  These warnings  and alerts which are displayed  do not
          go  into any significant  detail.  In  fact, this section  of the
          SGDB report is  the only  section which is  not copied  verbosely
          into the computer during  the processing phase.  In  other words,
          the details of each warning and/or  alert are not processed.  The
          reason for this  is to  keep the  BCAST database file  down to  a
          minimal size.   The smaller  each BCAST database  record is,  the
          more information  you will be able to store  in a given amount of
          disk  space.   If all  of the  possible details of  every various
          warning  and alert were processed, each  database record would be
          much larger than needed,  more difficult to process and  would be
          wasteful  with  disk  space.   All  that  is  really required  is
          knowledge of the  basic warnings and  alerts which are in  effect
          during each day.  The details of the warnings or alerts aren't as
          important.  If the  details are important, you are  encouraged to
          obtain  one  of  the  extensive  monthly  summaries  of  activity
          produced by the Solar Terrestrial  Dispatch, as made available on
          our computer BBS system and through anonymous FTP.
           
               The screens following  the warnings and alerts  summarize in






                                                                         10

          great detail  the data  which was  loaded from  the textual  SGDB
          report.  All of the various indices are listed.  Many of them are
          interpreted for you so you can better understand their meaning. 
           
               This  feature  may  be  executed  by   those  who  have  not
          registered the BCAST software package with us. 



          The Archive and Analysis Menu

               The  third function  of the  BCAST main menu  represents the
          heart of  BCAST:  the archive and analysis  features.  This is an
          extensive  menu  containing  all of  the  functions  necessary to
          maintain the    database,  archive  new data  to  disk,  generate
          reports, and graphically analyze the data in the database. 
           
               In order to encourage payment for this program, this section
          of  BCAST may be viewed but cannot be  used by those who have not
          registered their copy of BCAST with us.   In order to develop and
          maintain your own database of records,  you will need to purchase
          your copy  of the program by sending a  cheque or money order for
          $35.00 in either Canadian or U.S.  funds to the Solar Terrestrial
          Dispatch  (our  address was given  in "Registering BCAST" section
          of this manual).  After your  unique registration number has been
          returned to you with the simple instructions for making your copy
          of BCAST a  registered copy, you will  be able to access  and use
          this section of BCAST at your leisure. 


          Saving Loaded Data Sets to the Database

               BCAST  expects  to  find  its  database  file  in  the  same
          directory as  the executable  BCAST file (BCAST.EXE)  and with  a
          filename of "DATASETS.DAT".  If  the environment variable "BCAST"
          is not used  and you execute BCAST in a directory where this file
          does not exist, BCAST will not  use the database.  This behaviour
          allows   you  to   maintain  separate   databases  in   different
          directories.   To use  a specific  database, simply  move to  the
          directory containing the database and execute  BCAST.  If you are
          only maintaining one database,  it is usually most  convenient to
          set the environment variable BCAST to  the path of your BCAST.EXE
          and associated files (data files may be located elsewhere, as was
          described  earlier).   Using  the  environment variable  lets you
          execute and use BCAST from anywhere on your system.  

               Before this option can be executed, a dataset must be loaded
          into memory.   After you have  loaded a dataset into  memory, you
          may archive that dataset to your  database file using this option
          of the  Archive Menu.  To execute  this option, simply select the
          "Save Data Set"  option in the Archive Menu using the Up and Down
          arrow keys.   Alternatively,  you may  select this  menu item  by






                                                                         11

          pressing  the  corresponding  letter associated  with  that  menu
          choice.
           
               Before writing the new data set  to the database file, BCAST
          checks to make sure that  no other records in the database  match
          the  one you are attempting to archive.   If it finds a record in
          the   database  with  the  same  date  as  the  dataset  you  are
          attempting to archive,  a warning  is displayed on-screen  giving
          you  three   options.   You may  overwrite the  record, which  is
          useful  when  you need  to  correct or  modify a  record  in your
          database.   You may skip  the record, which  will force  BCAST to
          write the  dataset to  the database.   In this  case, nothing  is
          overwritten.  New  space within the  database is created for  the
          dataset you are saving.  If this  option is chosen, there will be
          two records  in your  database with  identical dates.   The  last
          option lets you  abort the  save procedure altogether.   In  this
          case, the database is left unchanged.  Nothing is written  to the
          database. 
           
               When  BCAST  saves   datasets  to  the  database   file,  it
          automatically archives the dataset fully sorted with the existing
          records in  the database.   It  sorts the  database according  to
          dates.   For this  reason, records  which are  archived near  the
          "front" of the database (ex.  a dataset which has a  date earlier
          than  anything  presently  existing in  the  database)  will take
          longer to save to  disk than a dataset which has  a date close to
          the present date.   The sorting process  occurs sequentially from
          the  lowest  to the  highest  dates.   That  is, a  dataset dated
          January 1, 1992  would appear BEFORE  a dataset dated January  2,
          1992.  Conversely,  a dataset dated  December 31, 1991 (note  the
          year) would appear  BEFORE the  datasets dated January  1 and  2,
          1992 in the database file. 
           
               This automatic sorting  feature significantly simplifies and
          speeds up many of the functions available with BCAST. 
           
               If the dataset is successfully archived to  the database, an
          "operation successful"  message is displayed on your  screen.  If
          an  error occurs,  you may be  returned to  DOS depending  on the
          severity  of the error.  All disk errors result in a  Fatal Error
          message which immediately returns  you to the DOS prompt  with an
          explanation. 


          Loading a Dataset from the Database

               This option loads a dataset which you previously archived to
          the database.   Using this option, you can examine  (via the main
          menu option "Review Data Sets")  the conditions and indices which
          were observed for any date contained in your database file. 
           
               You are simply prompted for the date of the dataset you wish






                                                                         12

          to  load  from the  database.    After specifying  a  date, BCAST
          searches  through  the  database  until  it finds  the  requested
          dataset.  If  the date you specify is either invalid or cannot be
          found in the database,  an error message is displayed  which then
          returns you to  the Archive Menu. 
           
               This option has a secondary effect  which may not be clearly
          apparent at first.   When BCAST graphically analyzes the datasets
          in the database  file, it always attempts  to graphically display
          the various datasets  with respect to  the date of the  currently
          loaded dataset. In other words, all  graphs or charts produced by
          BCAST will  be displayed so  that the LAST  line of the  graph or
          chart is the graph line  of the dataset which you  have currently
          loaded in memory.   If you do not have a  specific dataset loaded
          in memory, all  graphs are produced with the last  dataset of the
          database (ex. the  most recently  archived dataset) displayed  as
          the last graph line on the screen. 

               To better explain this feature,  let's assume that you  have
          200  datasets   archived  to  your  database  and   you  wish  to
          graphically analyze them.   Since BCAST can only fit  70 datasets
          on-screen at one time, it is necessary to select a portion of the
          200 datasets to graphically analyze.  One way to achieve this  is
          by loading datasets for specific dates into memory.  If a dataset
          is  loaded  into memory,  the date  of  that dataset  is  used to
          determine  which  portion  of  the  200 datasets  to  graphically
          display on-screen.   For  example, if  the 200  datasets in  your
          database were sequentially dated from January 1, 1991 to July 19,
          1991 (200 consecutive days), and you loaded a dataset into memory
          which was  dated March  11, 1991,  BCAST  would only  graphically
          analyze the datasets  from January 1, 1991 to March  11, 1991 (70
          days).  The  dataset for March 11,  1991 would be the  last graph
          line  displayed  on-screen.     Similarly,   if  you  wanted   to
          graphically display  the last  70 datasets  on-screen, you  would
          load the dataset which was dated July  19, 1991 into memory.  All
          graphical charts produced by BCAST follow this procedure.


          The Graphical Analysis Options

               BCAST provides a  set of  valuable graphical analysis  tools
          which  will help  you  better analyze  the cyclical  behaviour or
          other parameters of the datasets in your database. 

               Almost all of the various data contained in the SGDB reports
          can be graphically  analyzed using BCAST.   The only items  which
          are  not  analyzed  are  the  Boulder  and  Planetary  K-indices.
          Additional software to graphically display  the K-index data will
          soon be available from the Solar Terrestrial Dispatch.

               To  analyze  a  specific  set  of  data,  simply select  the
          appropriate  option from  the Archive  Menu  and press  ENTER, or






                                                                         13

          press  the  corresponding  letter  associated  with  the  desired
          function.
           
               BCAST produces two  types of  graphical charts depending  on
          what type of  data you are analyzing.   Linear data, such  as the
          10.7 cm solar radio flux or the geomagnetic data, use  the linear
          graphical functions.   Other datasets such as the  proton fluence
          or x-ray statistics  are analyzed  and graphed using  logarithmic
          graphical charts.  This significantly  improves the detail of the
          graphs. 
           
               There are several important functions  which can be executed
          while graphs of datasets  are displayed on-screen.  The  first is
          the ability to move  through the graph, line  by line, using  the
          left  and right arrow keys.   As you use the arrow keys, each new
          graph line you move to is highlighted.  Using the left arrow keys
          moves  the  highlighted area to  the left.   The right arrow  key
          moves the highlighted area  to the right.  In  addition, the date
          of  the   highlighted  graph  line  as well  as  the exact  value
          producing that line  is displayed  at the bottom  of the  screen.
          This lets you examine each line of the graph in detail.

               Version  1.01  of BCAST  also  permits examination  of other
          parts of the database while viewing graphical images.  The PAGEUP
          and PAGEDOWN keys shift  the graphs being viewed by the number of
          days  defined  in  the BCAST.INI  configuration  file  (under the
          GRAPHSTEP command).  The default is 35 days, which results in the
          graphs shifting  half of a screen left or  right each time one of
          these  keys  is pressed.   You  can  force BCAST  to move  to the
          beginning of the database by pressing the HOME key.  You can also
          display the last  70 days contained  in the database by  pressing
          the END key.
           
               Another  useful  function  which  can  be executed  while  a
          graphical  chart  is  displayed,  is  the  ability  to  save  the
          currently displayed graph  to a text ASCII file on disk.  After a
          graph has  been saved to disk, you can print  it out on a printer
          or transfer them electronically to other locations.
           
               To invoke this  disk saving function, simply  press "S" (for
          "S"ave) while any  graphical chart is  displayed on-screen.   The
          screen will immediately be converted to ASCII format and saved to
          disk under the file  name "GRAPH.TXT".  Each time you  press "S",
          the  graphical  chart  displayed  on-screen  is APPENDED  to  (or
          written to the end of) the GRAPH.TXT file.  This lets you compile
          an extensive set of graphs simply by  graphically analyzing those
          datasets  you need  and pressing  the "S"  key.   After  you have
          finished and exited the BCAST program  to the DOS prompt, you may
          display the  GRAPH.TXT file,  edit it  using your  favourite word
          processor, print it  out, transfer it  elsewhere, or do  whatever
          you see fit to do with it. 
           






                                                                         14

               To  continue to view  other datasets,  press ENTER  when you
          have finished viewing a  specific graphical chart.  To  abort the
          procedure and return to the archive menu, press the ESCape key. 


          Generating an Activity Summary Report

               This  option  of  the Archive  Menu  analyzes  the currently
          loaded  dataset  and   writes  a  summary  report   to  the  file
          "SUMMARY.TXT" on  disk.   All of  the indices  contained in  that
          dataset are written to the file,  along with the various warnings
          and  alerts which  were in  effect, etc.   This report-generation
          feature is most useful when data from the SGDB reports are  to be
          distributed throughout an  organization,  or transferred to other
          locations through e-mail  or modem.   This is also an  invaluable
          tool  for producing hard-copy  summaries of the  dataset you have
          loaded  in  memory.    It  may  then  be  filed  away for  future
          reference. 
           
               If the file  "SUMMARY.TXT" already  exists when you  execute
          this function, the contents of the  file will NOT be overwritten.
          All information is  appended to the  SUMMARY.TXT file.  You  will
          therefore be able to  store multiple summaries in a  single file,
          if so desired. 

               The  summary  file   is  created  in  the   current  working
          directory, not in the directory where the BCAST files are stored.


          Generating a Standard SGDB File & Modifying Records

               BCAST  has  the   ability  to  recreate  a   standard  Solar
          Geophysical Data  Broadcast format file.   This  is an  important
          function  if you need  to modify certain  indices or values  of a
          specific dataset in your archive. 
           
               To  use  this feature,  you must  have  a dataset  loaded in
          memory (either using the  first option of the Main  Menu [Process
          Data Set], or  the second option of the Archive Menu [Load a Data
          Set]).   After a dataset  has been loaded  in memory, a precisely
          formatted SGDB file can be created using this function. 
           
               Why would you  need to create  a standard  SGDB file in  the
          first place?   There are  a number of reasons.   You may  need to
          transfer a specific dataset you have in your archive to a  friend
          who is missing that  particular dataset.  You could  transfer the
          SUMMARY.TXT file, although this file is not in the correct format
          to be processed by others using  BCAST.  Using this function, you
          can recreate a copy of the SGDB for any dataset in  your archive,
          which may  then be  shared  with others  who are  using BCAST  to
          archive and analyze data.  
           






                                                                         15

               One of the primary reasons for requiring this function is to
          permit  the  easy  modification  of  specific  datasets  in  your
          database.  For example,  lets assume that one of your datasets in
          your database is corrupt.  Lets say that one of your  datasets in
          your database has  a bad value for  the 10.7 cm solar  radio flux
          and  you need to  correct it.   All you need  to do  is load that
          dataset into memory using  the second option of the  Archive Menu
          (Load a  Data Set),  and generate a  standard SGDB file  for that
          dataset.   The incorrect 10.7 cm  solar radio flux value  will be
          written  to  the SGDB.TXT  file.    Simply exit  BCAST,  edit the
          SGDB.TXT file  to correct  the 10.7  cm solar  radio flux  value.
          Then  reload  BCAST,  reprocess the  SGDB.TXT  file  so  that the
          corrected dataset  is reloaded  into memory  (using the  "Process
          Data  Set"  option of  the  Main  Menu), and  save  the corrected
          dataset to your database using the  "Save Data Set" option of the
          Archive Menu.    BCAST  will  detect  the  corrupted  dataset  by
          realizing that the  dataset you have  loaded into memory has  the
          same date as the  bad dataset in your archive.   It will then ask
          whether or not  you want to overwrite the dataset.  By responding
          so  that  BCAST   overwrites  the  incorrect  dataset,   you  can
          effectively correct the bad solar flux value in your database.  
           
               This procedure can  be carried out for any  of the values in
          your database.   It is a quick  and easy method of  modifying any
          dataset  in  your archive.    To  summarize,  simply extract  the
          dataset you  need to  correct to  a standard  SGDB file,  edit it
          using a word processor, reprocess it using BCAST and resave it to
          your  database  file  using  the  "O"verwrite option  which  will
          appear.
           
               This function  will not overwrite  any existing data  in the
          SGDB.TXT file if  it already exists  when you attempt to  produce
          the standard  SGDB file.   All data is  appended to  the SGDB.TXT
          file.  You may therefore create multiple SGDB reports in a single
          file, if desired.


          Dumping Data Sets to an ASCII File

               This powerful function lets you  dump the entire contents of
          your database to a text ASCII  file with the name "DATASETS.TXT".
          Use this function with  caution, since very large text  files can
          be created in the process.  
           
               During this procedure, BCAST runs through your database file
          multiple times, extracting each of the datasets from the database
          and saving them  to the  DATASETS.TXT file.   The resulting  text
          file is a  well-ordered, fully sorted, textual  representation of
          every set of data in your database.  
           
               This feature becomes particularly important when you need to
          analyze the data  externally using  something like a  statistical






                                                                         16

          computer program, a data plotter, or  a spreadsheet.  Also, since
          the data is dumped  in a pure ASCII format, you can edit the text
          file and extract only the information you require.


          Deleting Data Sets from the Database

               The  only  other  function   required  to  provide  complete
          management control  over your  database is  a method  of deleting
          datasets from your database.  That is the purpose of this Archive
          Menu function.  
           
               To  delete  a  specific dataset  from  your  archive, simply
          select this function.  BCAST will prompt  you for the date of the
          dataset to delete.   After typing in the date,  BCAST will search
          through the database  until it  finds a dataset  with a  matching
          date.    It will  then  request confirmation  from  you.   If you
          respond in  the affirmative, BCAST  will delete the  dataset from
          your database.   If you do not confirm deletion, BCAST will abort
          the procedure and leave your database untouched.  

               It  is  important to  note  that  after you  have  confirmed
          deletion, BCAST will delete ALL datasets  with dates matching the
          one you supplied,  not only  the one which  BCAST first  detects.
          Therefore, using this command you can delete accidental redundant
          datasets from your  database (as can occur if you  save a dataset
          to your archive which already exists).  


          Returning to the Main Menu

               You can return from the Archive Menu to the main menu at any
          time by either pressing the ESCape  key, or selecting the "Return
          to  the Main Menu"  option.  When  running BCAST, the  ESCape key
          serves as the "abort" key.  It  will abort almost any process and
          return you to a menu. 


          Exiting BCAST and Returning to DOS

               To exit BCAST  and return to  the DOS prompt, either  select
          the "Exit Program"  command of the Main Menu or  press the ESCape
          key at the  Main Menu prompt.   Either method will terminate  the
          program and return you to the DOS prompt. 


          The Batch Processing Feature of BCAST

               BCAST  provides a powerful  batch processing  function which
          can  be  invoked  at  the  command  line.    This  function  will
          automatically  process  large numbers  of  SGDB report  files and
          archive them to  your database.  All SGDB files processed in this






                                                                         17

          manner are automatically  and accurately  saved to your  database
          fully sorted.
           
               To execute this  command, simply run BCAST  with the command
          line parameter "-b" (or "-B", it  is not case sensitive) followed
          by  the name(s)  of  the  files  you want  to  be  processed  and
          archived.  Wildcards in the filenames are permitted.  
           
               For example, to create a database file containing every SGDB
          report having the  extension DLY,  you would simply  type: "BCAST
          -B *.DLY" (excluding the parenthesis, of course) and press ENTER.
          BCAST  will  automatically begin  processing and  archiving every
          file containing the extension ".DLY".  As each file is processed,
          its name is displayed  on-screen so you can monitor  the progress
          of the  processing.  It does  not matter which order  you specify
          files to be processed.  BCAST automatically sorts the database so
          that all added datasets are placed in the proper position  in the
          archive.

               During  the  batch processing  phase,  if BCAST  attempts to
          process a dataset  which already exists in  your archive (ex.   a
          dataset  with the  same  date), BCAST  discards  the dataset  and
          processes the next file.   You may  therefore process a group  of
          files without needing  to worry  about accidentally processing  a
          duplicate dataset.  BCAST will not  batch process a dataset which
          already exist in your database.
           
               After all of the files have  been processed, BCAST loads and
          displays the title page, followed by the Main Menu, etc.

               Please  note that  the last  file processed  will reside  in
          memory while BCAST  executes.   As a result,  if you  graphically
          analyze  your  database  after  executing  the  batch  processing
          feature,  the graphical charts will be displayed according to the
          date  of  the last  dataset processed.    Consult the  section on
          "Loading  a Data  Set  from the  Database"  for more  information
          regarding this feature.  

               This feature  is only available to those who have registered
          their copy  of BCAST  with us  (consult the  section "Registering
          BCAST"  in  this  manual  or  the file  "REGISTER.DOC"  for  more
          information regarding registration).  


          Alternate Methods of Executing BCAST

               You can run BCAST  and process a textual SGDB dataset at the
          same time by executing  BCAST with an extra parameter  specifying
          the name  of the file to process.   For example, to execute BCAST
          and automatically process the file "SGDB.TXT" so that the dataset
          contained in that file is loaded  in memory, simply execute BCAST
          using the  command: "BCAST  SGDB.TXT".   This will  run BCAST  as






                                                                         18

          usual, but will force it to process the file SGDB.TXT before  the
          main  menu  appears.    This  may  speed  up  the  procedure  for
          processing and analyzing the dataset.

               Please note that  the dataset loaded  in this manner is  NOT
          archived to your  database.  It is  simply loaded in memory.   If
          you want to archive  the dataset to your database,  you will need
          to either include  the "-B" (batch  processing) parameter on  the
          command line  or use  the "Process  Dataset" option  of the  main
          menu.
           
               This function may be used on unregistered copies of BCAST.
