/* Copyright (c) by Contact Plus Corporation 1992, All rights reserved */

#define NCALLS		30	/* record the last 30 calls */
#define NLETTERS	15	/* record the last 15 letters */
#define NREMINDERS	15	/* log 15 different tickler dates */


#define Date unsigned int
#define Time unsigned long

typedef struct contact {
    char  key[16];		/* 15 character key */
    char  lname[21];		/* 20 char last name */
    char  fname[18];		/* 17 char first name */
    char  salut[12];		/* 11 char salutation */
    char  title[31];		/* 30 character title */
    char  company[31];		/* 30 char company name */
    char  address1[31];		/* 30 char home address */
    char  address2[31];		/* 30 char home address */
    char  city[16];		/* 15 char city */
    char  state[11];		/* 10 char state */
    char  zip[11];		/* 10 char zip code */
    char  country[10];		/* 9  char country */
    char  phone1[21];		/* 20 char home phone */
    char  phone2[21];		/* 20 char work phone */

    char  memo[41];		/* 40 character memo */

    char  user1[16];		/* 15 character user def field 1 */
    char  user2[16];		/* 15 character user def field 2 */

    char  user3[25];		/* 24 character user def field 3 */
    char  user4[25];		/* 24 character user def field 4 */
    
    char  user5[25];		/* 24 character user def field 3 */
    char  user6[25];		/* 24 character user def field 4 */
    
    long   codes;		/* user defined codes */

    Date  when1;		/* first contact date */
    Date  when2;		/* next contact date */
    Date  when3;		/* last contact date */

    struct phone {
        Time phonewhen;
	char pstat;		/* call status ('b', 'n', 'l', 'o', 'i') */
	unsigned int pelapse;	/* number of minutes elapsed */ 
	char pmemo[41];		/* long phone message field */
    } phone[NCALLS];

    struct letter {
        Date letterwhen;
	char lstat;		/* 'R' - recvd letter, 'S' - sent letter */
	char lmemo[21];		/* letter memo */
	char lfile[13];		/* file name of letter */
    } letter[NLETTERS+1];

    struct remind {
        Date remindwhen;	/* when reminder is needed */
	char rmemo[11];		/* 10 char tickler */
	char rnotes[31];	/* 30 char notes field */
	char rstat;		/* 1 = DONE, 2 = NOTDONE, 0 - N/A */
    } remind[NREMINDERS];

    Time  added;		/* when this record was added */
    Time  changed;		/* date of last operator change */

} contact;



/* ********************* NOTE FORMAT ************************************ */

typedef struct note {
    long  recno;		/* record number of Contact.dt */
    Time  notetime;		/* date/time of note */
    char  note[251];		/* actual note (null terminated) */
    				/* 5 lines by 50 characters */
} note;

