****************************************************************************
* DBE_07.PRG
*
* CALLED FROM DBE_DEMO.PRG
*
* Demonstrates the use of the fields array as the 5th parameter of DBEDIT()
* Adds the header array.
*
* Uses a User Defined Function that does nothing but emulate the
* default action of DBEDIT().
* 
* Displays fields from 2 databases related by workplace I.D. 
*
*  FUNCTION     SOURCE
*  ===========  ==============
*  SHADOW()     DBE_UDF.PRG
*  DBEDIT()     EXTEND.LIB
*
*  NOTE:
*
*  Following Rick Spence's example (See Reference #5), let's start with
*  a skeleton UDF that just emulates the default action of DBEDIT.  We 
*  can later modify this UDF to provide the custom features we need
*  for our application.
*
*  See DBE_CNST.PRG for the definitions of the CONSTANTS used by the UDF.
*
*****************************************************************************
SELECT 0
USE SHOP INDEX SHOPWPID
SELECT 0
USE PEOPLE
SET RELATION TO WPID INTO SHOP
DECLARE a_field[3], a_hdr[3]
a_field[1]="PEOPLE->NAME"
a_hdr[1]  ="NAME"
a_field[2]="PEOPLE->RANK"
a_hdr[2]  ="RANK"
a_field[3]="SHOP->SHOP"
a_hdr[3]  ="SHOP"
m_hdr_sep= CHR(205)+CHR(209)+CHR(205)
m_ftr_sep= CHR(205)+CHR(207)+CHR(205)
@ 23, 1 SAY "<Esc>=Exit    <Enter>=Select"
SHADOW( 4, 4, 19, 76, "N+/W")
@ 6, 4 SAY CHR(204)
@ 6,76 SAY CHR(185)
DBEDIT( 5, 5, 19, 75, a_field, "dbe_ud07", .f., a_hdr, m_hdr_sep,.F., m_ftr_sep )
RETURN
*****************************************************************************

*...
* The following function does NOT add anything to the default action
* of DBEDIT().  It is included as a starting point for us to use to 
* customize DBEDIT() to our needs.
*...

FUNCTION DBE_UD07
PARAMETERS in_status, fld_ptr
PRIVATE ret_val, keypress
DO CASE
CASE in_status = DBE_EXCEPT
  keypress= LASTKEY()
  DO CASE
  CASE keypress = ESC
    ret_val= DBE_QUIT
  CASE keypress = ENTER
    ret_val= DBE_QUIT    
  OTHERWISE
    ret_val= DBE_QUIT
  ENDCASE
OTHERWISE
  ret_val= DBE_CONT
ENDCASE
RETURN( ret_val )
*****************************************************************************

*<EOF: DBE_07.PRG *-------------------------------------------------------*
