****************************************************************************
* DBE_08.PRG
*
* CALLED FROM DBE_DEMO.PRG
*
* Demonstrates the use of the fields array as the 5th parameter of DBEDIT()
* Adds the header array.
*
* Adds field editing capability to the user defined function
*
* Displays fields from 2 databases related by workplace I.D. 
*
*  FUNCTION     SOURCE
*  ===========  ==============
*  SHADOW()     DBE_UDF.PRG
*  DBEDIT()     EXTEND.LIB
*
*
*  NOTE:
*
*  Now we'll add a raw field editing capability to the previous example's
*  UDF.  Notice how I used the KEYBOARD command to jump into a field 
*  whenever an alphanumeric (plus other common characters) key is pressed.
*
*****************************************************************************
SELECT 0
USE SHOP INDEX SHOPWPID
SELECT 0
USE PEOPLE
SET RELATION TO WPID INTO SHOP
DECLARE a_field[3], a_hdr[3]
a_field[1]="PEOPLE->NAME"
a_hdr[1]  ="NAME"
a_field[2]="PEOPLE->RANK"
a_hdr[2]  ="RANK"
a_field[3]="SHOP->SHOP"
a_hdr[3]  ="SHOP"
m_hdr_sep= CHR(205)+CHR(209)+CHR(205)
m_ftr_sep= CHR(205)+CHR(207)+CHR(205)
@ 23, 1 SAY "Use cursor keys to move.  Press <Esc> to exit."
SHADOW( 4, 4, 19, 76, "N+/W")
@ 6, 4 SAY CHR(204)
@ 6,76 SAY CHR(185)
DBEDIT( 5, 5, 19, 75, a_field, "dbe_ud08", .f., a_hdr, m_hdr_sep,.F., m_ftr_sep )
RETURN
*****************************************************************************


FUNCTION DBE_UD08
PARAMETERS in_status, fld_ptr
PRIVATE ret_val, keypress, cur_field
DO CASE
CASE in_status = DBE_EXCEPT
  keypress= LASTKEY()
  DO CASE
  CASE keypress = ESC
    ret_val= DBE_QUIT
  CASE keypress = ENTER
    SET CURSOR ON
    cur_field= a_field[ fld_ptr ]
    @ ROW(), COL() GET &cur_field
    READ
    SET CURSOR OFF
    ret_val= DBE_CONT
  CASE keypress > 31 .AND. keypress < 127   
    KEYBOARD CHR( ENTER ) + CHR( keypress )  && Stuff the keyboard to enter
    ret_val= DBE_CONT                        && the edit mode.
  OTHERWISE
    ret_val= DBE_QUIT
  ENDCASE
OTHERWISE
  ret_val= DBE_CONT
ENDCASE
RETURN( ret_val )
*****************************************************************************

*<EOF: DBE_08.PRG *-------------------------------------------------------*
