****************************************************************************
* DBE_09.PRG
*
* CALLED FROM DBE_DEMO.PRG
*
* Demonstrates the use of the fields array as the 5th parameter of DBEDIT()
* Adds the header array.
*
* Adds field editing capability to the user defined function
*
* Displays fields from 2 databases related by workplace I.D. 
*
*  FUNCTION     SOURCE
*  ===========  ==============
*  SHADOW()     DBE_UDF.PRG
*  DBEDIT()     EXTEND.LIB
*  PICKRANK()   DBE_UDF.PRG
*
*  NOTE:
*
*  Now we're getting to the REAL fun!  I've added a function called 
*  PICKRANK() to pop up a selection list so my user will not have to
*  remember the correct abbreviation for the Air Force ranks.
*
*  I really enjoy saving my users as many keystrokes as I can, so I
*  use lots of lookup tables in my applications.  An added benefit 
*  is consistent data entry for data queries!
*
*
*  Edit the RANK field to see how the PICKRANK() function works.
*
*****************************************************************************
SELECT 0
USE SHOP INDEX SHOPWPID
SELECT 0
USE PEOPLE
SET RELATION TO WPID INTO SHOP
DECLARE a_field[3], a_hdr[3]
a_field[1]="PEOPLE->NAME"
a_hdr[1]  ="NAME"
a_field[2]="PEOPLE->RANK"
a_hdr[2]  ="RANK"
a_field[3]="SHOP->SHOP"
a_hdr[3]  ="SHOP"
m_hdr_sep= CHR(205)+CHR(209)+CHR(205)
m_ftr_sep= CHR(205)+CHR(207)+CHR(205)
@ 23, 1 SAY "Use cursor keys to move.  Press <Esc> to exit."
SHADOW( 4, 4, 19, 76, "N+/W")
@ 6, 4 SAY CHR(204)
@ 6,76 SAY CHR(185)
DBEDIT( 5, 5, 19, 75, a_field, "dbe_ud09", .f., a_hdr, m_hdr_sep,.F., m_ftr_sep )
RETURN
*****************************************************************************


FUNCTION DBE_UD09
PARAMETERS in_status, fld_ptr
PRIVATE ret_val, keypress, cur_field
DO CASE
CASE in_status = DBE_EXCEPT
  keypress= LASTKEY()
  DO CASE
  CASE keypress = ESC
    ret_val= DBE_QUIT
  CASE keypress = ENTER
    cur_field= a_field[ fld_ptr ]
    DO CASE
    CASE cur_field= "PEOPLE->RANK"
      PICKRANK()
    OTHERWISE
      SET CURSOR ON
      @ ROW(), COL() GET &cur_field
      READ
      SET CURSOR OFF
    ENDCASE
    ret_val= DBE_CONT
  CASE keypress > 31 .AND. keypress < 127   
    KEYBOARD CHR( ENTER ) + CHR( keypress )  && Stuff the keyboard to enter
    ret_val= DBE_CONT                        && the edit mode.
  OTHERWISE
    ret_val= DBE_QUIT
  ENDCASE
OTHERWISE
  ret_val= DBE_CONT
ENDCASE
RETURN( ret_val )
*****************************************************************************


*<EOF: DBE_09.PRG *-------------------------------------------------------*
