****************************************************************************
* DBE_10.PRG
*
* CALLED FROM DBE_DEMO.PRG
*
* Demonstrates the use of the fields array as the 5th parameter of DBEDIT()
* Adds the header array.
*
* Adds field editing capability to the user defined function
*
* Displays fields from 2 databases related by workplace I.D. 
*
*  FUNCTION     SOURCE
*  ===========  ==============
*  SHADOW()     DBE_UDF.PRG
*  DBEDIT()     EXTEND.LIB
*  PICKRANK()   DBE_UDF.PRG
*
*  NOTE:
*
*  This final demonstration uses all 12 parameters and demonstrates 
*  how you can browse more than a screenful of fields.
*
*  I personally do not use the column formatting array very often.
*  I changed the SET DATE format to ANSI (YY.MM.DD) just to show
*  how the picture string formatting works.
*
*  I'm content with the single line column separator.  Notice that I had
*  to include a space on either side of my column separator so that my
*  lines would connect properly.
*
*  I used the data file name as a footer for each column for lack of
*  a better example.
*
*****************************************************************************
SELECT 0
USE SHOP INDEX SHOPWPID
SELECT 0
USE PEOPLE
SET RELATION TO WPID INTO SHOP

SET DATE ANSI   && Just to demonstrate the picture formatting array.

DECLARE a_field[7], a_hdr[7], a_ftr[7], a_pic[7]
a_field[1]="PEOPLE->NAME"
a_hdr[1]  ="NAME"
a_ftr[1]  ="PEOPLE.DBF"
a_pic[1]  = "@!"
a_field[2]="PEOPLE->RANK"
a_hdr[2]  ="RANK"
a_ftr[2]  ="PEOPLE.DBF"
a_pic[2]  =""
a_field[3]="PEOPLE->LAST_EXAM"
a_hdr[3]  ="LAST EXAM"
a_ftr[3]  ="PEOPLE.DBF"
a_pic[3]  = "@D"
a_field[4]="PEOPLE->WPID"
a_hdr[4]  ="WPID"
a_ftr[4]  ="PEOPLE.DBF"
a_pic[4]  ="999A"
a_field[5]="SHOP->EXAMCODE"
a_hdr[5]  ="EXAM;CODE"    && Forces EXAM and CODE onto 2 lines!
a_ftr[5]  ="SHOP.DBF"
a_pic[5]  =""
a_field[6]="SHOP->UNIT"
a_hdr[6]  ="UNIT"
a_ftr[6]  ="SHOP.DBF"
a_pic[6]  =""
a_field[7]="SHOP->SHOP"
a_hdr[7]  ="SHOP"
a_ftr[7]  ="SHOP.DBF"
a_pic[7]  =""
m_hdr_sep= CHR(205)+CHR(209)+CHR(205)
m_ftr_sep= CHR(205)+CHR(207)+CHR(205)
m_col_sep= " "+ CHR(179) + " "
@ 23, 0 
@ 23, 1 SAY "Use cursor keys to move.  Press <Esc> to exit."
SHADOW( 4, 4, 19, 76, "N+/W")

* Lowered the following two lines because of the two line header "EXAM CODE"

@  7, 4 SAY CHR(204)
@  7,76 SAY CHR(185)
@ 17, 4 SAY CHR(204)
@ 17,76 SAY CHR(185)
* Changed the lower line (3rd parameter) because of added footer parameter

DBEDIT( 5, 5, 18, 75, a_field, "dbe_ud10", ;
        a_pic, a_hdr, m_hdr_sep, m_col_sep, m_ftr_sep, a_ftr )
SET DATE AMERICAN
RETURN
*****************************************************************************


FUNCTION DBE_UD10
PARAMETERS in_status, fld_ptr
PRIVATE ret_val, keypress, cur_field
DO CASE
CASE in_status = DBE_EXCEPT
  keypress= LASTKEY()
  DO CASE
  CASE keypress = ESC
    ret_val= DBE_QUIT
  CASE keypress = ENTER
    cur_field= a_field[ fld_ptr ]
    do_read= .T.
    DO CASE
    CASE cur_field= "PEOPLE->NAME"
      @ ROW(), COL() GET PEOPLE->NAME PICTURE "@!"
    CASE cur_field= "PEOPLE->RANK"
      PICKRANK()
      do_read= .F.
    CASE cur_field= "PEOPLE->LAST_EXAM"
      @ ROW(), COL() GET PEOPLE->LAST_EXAM PICTURE "@D"
    CASE cur_field= "PEOPLE->WPID"
      @ ROW(), COL() GET PEOPLE->WPID PICTURE "999A"
    OTHERWISE
      TONE(1000,6)
      TONE(2000,6)
      in_color= COLOR( normal )
      @ 23, 0 CLEAR
      @ 23, 1 SAY "Cannot edit this field!"
      INKEY(10)
      @ 23, 0 CLEAR
      COLOR( in_color )
      do_read= .F.
    ENDCASE
    IF do_read
      SET CURSOR ON
      READ
      SET CURSOR OFF
    ENDIF
    ret_val= DBE_CONT
  CASE keypress > 31 .AND. keypress < 127   
    KEYBOARD CHR( ENTER ) + CHR( keypress )  && Stuff the keyboard to enter
    ret_val= DBE_CONT                        && the edit mode.
  OTHERWISE
    ret_val= DBE_QUIT
  ENDCASE
OTHERWISE
  ret_val= DBE_CONT
ENDCASE
RETURN( ret_val )
*****************************************************************************

*<EOF: DBE_10.PRG *-------------------------------------------------------*
