*************************************************************************
* DBE_UDF.PRG
*
* Contains USER DEFINED FUNCTIONS used by DBE_DEMO.PRG
*************************************************************************

FUNCTION COLOR
PARAMETER in_color

PUBLIC color_save
color_save= SETCOLOR()
IF ISCOLOR() .AND. mcolor = "C"
  SET COLOR TO &in_color  
ELSE
  SET COLOR TO
ENDIF
RETURN(color_save)
*********************************************


****************************
*              SHADOW()
****************************
* SYNTAX.....: SHADOW( <expN1>, <expN2>, <expN3>, <expN4>, <expC1>, [ <expC2> ] )
*
* ARGUMENTS..: <expN>s 1 - 4 are coordinates for the upper left corner and
*              lower right corner of a box.
*              <expC1> is the desired color of the box.   
*              <expC2> is an optional title for the menu box.
*
* RETURNS....:  A character string.
*               A null string is always returned.
*
* NOTE.......:  The first four parameters are REQUIRED!
*
* EXAMPLE....:  SHADOW( 4, 4, 13, 40, "W+/R", "MAIN MENU")
*
*****************************

FUNCTION SHADOW
PRIVATE lr, lc, rr, rc, boxcolor, title 
PARAMETERS lr, lc, rr, rc, boxcolor, title
COLOR( "N/N" )
@ M->lr + 1, M->lc + 1 CLEAR TO  M->rr + 1, M->rc + 2 
IF PCOUNT() < 5
  boxcolor= SETCOLOR()
ENDIF
COLOR(boxcolor)
@ M->lr, M->lc, M->rr, M->rc BOX CHR(201)+CHR(205)+CHR(187)+CHR(186)+CHR(188)+CHR(205)+CHR(200)+CHR(186)+CHR(32)
IF PCOUNT() > 5 
  IF .NOT. EMPTY( title )
    @ M->lr, M-> lc + 2 SAY CHR(181) + SPACE(1) + title + SPACE(1) + CHR(198)
  ENDIF
ENDIF
RETURN("")
*******************************************************************

FUNCTION SHOWTEXT
PARAMETER in_file, is_demo
IF PCOUNT() < 2
  is_demo= .F.
ENDIF
IF FILE( in_file )
  @ 0, 0
  @ 0,60 SAY "LINE:"   
  @ 3, 0 CLEAR TO 21, 79
  @ 23, 1 SAY "<Esc>= Exit   " + CHR(24) + CHR(25) + "   <PgUp>   <PgDn>   <Ctrl>-<PgUp>   <Ctrl>-<PgDn>"
  IF is_demo
    @ 24, 1 SAY "Press       to see the demonstration of this source code."
    COLOR("GR+/R")
    @ 24, 7 SAY "<F10>"
  ENDIF
  COLOR( "W+/N" )
  cText= MEMOREAD( in_file )
  SET CURSOR ON
  MEMOEDIT( cText, 3, 0, 21, 79, .F., "me_udf")
  SET CURSOR OFF
  COLOR( normal )
  @ 0, 0
  @ 3, 0 CLEAR TO 21, 79
  @ 23, 0 CLEAR
  RELEASE cText
ENDIF
RETURN("")
**********************************************************************

FUNCTION me_udf
PARAMETERS in_status, in_line
COLOR( normal )
@ 0, 66 SAY TRANSFORM( in_line, "999" )
COLOR( "W+/N" )
IF LASTKEY() = -9
  RETURN(27)
ENDIF
RETURN(0)
***********************************************************************

****************************
*              MILDATE()
****************************
* SYNTAX.....:  MILDATE( [expD ] )
*
* ARGUMENTS..:  <expD> denotes the date to convert to DD MMM YY format.
*
* RETURNS....:  A character string.
*               Format:  DD MMM YY 
*
* NOTE.......:  Uses DATE() as default if no parameter is passed.
*
* EXAMPLE....:  @ 1,60 SAY MILDATE()   &&                  12 Oct 89
*****************************

FUNCTION MILDATE
PARAMETER in_date
IF PCOUNT() = 0
   in_date = DATE()
ENDIF   
IF TYPE("in_date")="D" 
  IF EMPTY( in_date )
    out_date= SPACE(9)
  ELSE
    PRIVATE m_day, m_month, m_year, out_date
    m_day = TRANSFORM( DAY( in_date ) , "99" )
    m_month = SUBSTR(CMONTH(in_date),1,3)
    m_year = SUBSTR( STR( YEAR( in_date ), 4 ), 3, 2 )
    out_date = m_day + " " + m_month + " " + m_year
  ENDIF
ELSE
  out_date = SPACE(9)
ENDIF
RETURN(out_date)
**************************************************************


FUNCTION PICKRANK
DECLARE a_rank[18]
a_rank[01]="AB "
a_rank[02]="AMN"
a_rank[03]="A1C"
a_rank[04]="SRA"
a_rank[05]="SGT"
a_rank[06]="SSG"
a_rank[07]="TSG"
a_rank[08]="MSG"
a_rank[09]="SMS"
a_rank[10]="CMS"
a_rank[11]="2LT"
a_rank[12]="1LT"
a_rank[13]="CPT"
a_rank[14]="MAJ"
a_rank[15]="LTC"
a_rank[16]="COL"
a_rank[17]="CIV"
a_rank[18]="   "
SAVE SCREEN
in_color= SETCOLOR()
SHADOW( 2, 70, 21, 74, "W+/R")
rank_nbr= ACHOICE( 3, 71, 20, 73, a_rank )
IF rank_nbr > 0
  REPLACE RANK WITH a_rank[ rank_nbr ]
ENDIF
COLOR( in_color )
RESTORE SCREEN
RETURN("")
*****************************************************************************

