@echo off
echo off
rem PhDbase installation batch file, modified 10/29/91.
cls
echo.  
echo Ŀ
echo                     PhDbase 2.0 Installation                            
echo 
echo   This program will install PhDbase 2.0 into your FoxPro directory.  
echo   It will place the files PHDBASE.APP, PHDBASE.SET, PHDBASE.HLP, 
echo   PHDBASE.FPT, and PHSAMPLE.DBF directly into your FoxPro directory.  
echo   It will also create a subdirectory within your FoxPro directory 
echo   called PHDBASE (i.e. C:\FOXPRO2\PHDBASE\) which will contain
echo   PhDbase's auxiliary documentation files (such as README.DOC).
echo.  
echo   If you are installing PhDbase from a floppy disk, move to your FoxPro
echo   home directory and type "a:install" or "b:install".
echo.  
echo   If you are installing a version of PhDbase that was compressed for
echo   electronic distribution, uncompress all the files into a temporary
echo   directory, and make that the current directory.  Now type "install xxx",
echo   replacing xxx with your FoxPro directory, INCLUDING A TRAILING BACKSLASH.
echo   (e.g. "install c:\foxpro2\").  If you installed from a temporary
echo   directory, you may then delete the files from the temporary directory.
echo.  
echo   Press Ctrl-C now to abort the installation process, or press any
echo   other key to continue...
pause >nul
cls
echo.  
echo Ŀ
echo                Checking for presence of FOXPRO*.EXE...                  
echo 
if exist %1foxpro*.exe goto okay
if not .%1 == . goto specified
echo   Can't find FOXPRO*.EXE in the current directory!
echo.  
echo   Please change directories to your FoxPro directory and then run
echo   install again.  Or, if you're installing from a subdirectory on a
echo   hard disk, specify your FoxPro directory on the install command line.
goto exit
:specified
echo   Can't find FOXPRO*.EXE in %1!
echo.  
echo   Make sure your path specification includes the trailing backslash and
echo   then run install again.  Or, if you're installing from a floppy, you
echo   can switch to your FoxPro directory and type A:INSTALL or B:INSTALL.
goto exit
:okay
echo   Found FOXPRO*.EXE...
rem
rem Set install drive to A:, B:, C:, or D:.
rem
for %%f in (a:install,A:INSTALL) do if %0 == %%f goto adrive
for %%f in (b:install,B:INSTALL) do if %0 == %%f goto bdrive
for %%f in (c:install,C:INSTALL) do if %0 == %%f goto cdrive
for %%f in (d:install,D:INSTALL) do if %0 == %%f goto ddrive
set %_drive=
rem
rem If no drive, don't allow anything but "install" by itself.
rem
for %%f in (install,INSTALL) do if %0 == %%f goto skipdrive
echo.  
echo  There are two valid forms of the install command.  If you are
echo  installing from a floppy disk, switch to your FoxPro home directory
echo  and type "a:install" or "b:install".  If you have already copied
echo  or unzipped the PhDbase files to a subdirectory on your hard disk,
echo  switch to that directory and type "install xxx", where xxx is the
echo  full path to your FoxPro home directory, including the trailing
echo  backslash.
goto exit
:adrive
set %_drive=a:
goto skipdrive
:bdrive
set %_drive=b:
goto skipdrive
:cdrive
set %_drive=c:
goto skipdrive
:ddrive
set %_drive=d:
:skipdrive
rem
rem Make sure we're not going to be copying the FoxPro directory
rem
if not exist %_drive%foxpro*.exe goto not_in_foxpro
echo.  
echo   You have apparently already copied or unzipped the PhDbase files
echo   to your FoxPro directory.  In this case, no additional installation
echo   is needed.
echo.  
goto all_done
:not_in_foxpro
echo.  
echo Ŀ
echo                Copying files to FoxPro directory...                     
echo 
echo   Copying PHDBASE.APP...
copy %_drive%phdbase.app %1phdbase.app >nul
echo   Copying PHDBASE.SET...
copy %_drive%phdbase.set %1phdbase.set >nul
echo   Copying PHDBASE.HLP...
copy %_drive%phdbase.hlp %1phdbase.hlp >nul
echo   Copying PHDBASE.FPT...
copy %_drive%phdbase.fpt %1phdbase.fpt >nul
echo   Copying PHSAMPLE.DBF...
copy %_drive%phsample.dbf %1phsample.dbf >nul
echo.  
echo Ŀ
echo                Copying files to PhDbase subdirectory...                 
echo 
echo   Creating PhDbase subdirectory...
if not exist %1phdbase\*.* md %1phdbase
echo   Copying auxiliary files...
copy %_drive%*.* %1phdbase >nul
rem
rem Remove redundant files.
rem
if exist %1phdbase\phdbase.app del %1phdbase\phdbase.app >nul
if exist %1phdbase\phdbase.set del %1phdbase\phdbase.set >nul
if exist %1phdbase\phdbase.hlp del %1phdbase\phdbase.hlp >nul
if exist %1phdbase\phdbase.fpt del %1phdbase\phdbase.fpt >nul
if exist %1phdbase\phsample.dbf del %1phdbase\phsample.dbf >nul
rem
set %_drive=
:all_done
echo.  
echo   Installation done!
echo.  
echo   To install PhDbase on your FoxPro system menu,
echo   start up FoxPro and type DO %1PHDBASE.
:exit
