* sample jkey calls.  Uses FOXHELP.DBF for example purposes
*
**** First we will create a test database called JKEYSAMP.DBF
**** from the FOXHELP table.  It will create an index on the
**** TOPIC field, which will be used for jkey.

set talk off
OldSysMenu = set("sysmenu")

set safe on
close data
if !file("jkeysamp.dbf")
	use (sys(2004)+"foxhelp") again && open the FOXHELP file
	copy to jkeysamp fields topic, class
	use jkeysamp
	index on upper(topic) tag topic
endif

**** Load JKEY into memory
set libr to jkey addi

**** Defin the window that will be used for the browse.
define window jbrowser from 10, 5 to 20, 75 color sche 10 ;
    close float grow zoom

**** Open the JKEYSAMP file (created above)
use jkeysamp order topic

**** Set the SYSMENU OFF before using JKEY.
set sysmenu off

**** Start JKEY up - telling it to convert all key presses to upper
**** case.
=jkeyinit("U")

**** Do the browse, after some instructions...
clear
@ 2, 2 say '=jKeyInit("U")'
@ 4, 2 say "Try typing things like SET, BROWSE, SUBS"
@ 6, 2 say "Press [Enter] to exit JKEY"

push key clear
on key label enter keyb chr(23)
brow window jbrowser

**** Stop JKEY from intercepting keys
=jkeycanc()
pop key

**** Determine wether or not the last keypress resulted in a
**** successfull seek.
if jkeyfound()
	? "Got one"
else
	? "Oh well..."
endif

****
**** An example with the "SEEK PREFIX" parameter added...
****
clear
@ 2, 2 say '=jKeyInit("U", "SET ")'
@ 4, 2 say "Try typing things like TALK, and NEAR"
@ 6, 2 say "Press [Enter] to exit JKEY"


push key clear
on key label enter keyb chr(23)
=jkeyinit("U", "SET ")
brow window jbrowser key "SET "
=jkeycanc()
pop key


****
**** An example with the "TALK PREFIX" parameter added...
****
clear
@ 2, 2 say '=jKeyInit("U", "SET ", "Find this: ")'
@ 4, 2 say "Try typing things like TALK, and NEAR"
@ 6, 2 say "Press [Enter] to exit JKEY"

push key clear
on key label enter keyb chr(23)
=jkeyinit("U", "SET ", "Find this: ")
brow window jbrowser key "SET "
=jkeycanc()
pop key


****
**** An example with the "TALK PREFIX" parameter added, but without
**** a SEEK PREFIX
clear
@ 2, 2 say '=jKeyInit("U", "", "Find this: ")'
@ 4, 2 say "Try typing things like SET, BROWSE, SUBS"
@ 6, 2 say "Press [Enter] to exit JKEY"

push key clear
on key label enter keyb chr(23)
=jkeyinit("U", "", "Find this: ")
brow window jbrowser
=jkeycanc()
pop key

****
**** An example with a user defined TALK WINDOW.
****
clear
@ 2, 2 say '=jKeyInit("U", "", "*")'
@ 4, 2 say "Try typing things like SET, BROWSE, SUBS"
@ 6, 2 say "Press [Enter] to exit JKEY"

define wind joe from 22, 10 to 22, 70 none colo sche 7
acti wind joe
@ 0, 0 say "Search for: "
push key clear
on key label enter keyb chr(23)

=jkeyinit("U", "", "*")
brow window jbrowser
=jkeycanc()
rele wind joe
pop key


set sysmenu &OldSysMenu.
close data
clear
=jkeyabout()

**** the following is necesarry because FoxPro needs the full path
**** name of the library to release it.
l_libr = plGetLib("jkey")
rele libr (l_libr)


***********************************************************************
* plGetLib.prg
* Joseph A. Gotthelf
*
* Copyright 1992, August Technologies Inc.
*
* return the full pathname for a library so it can be released
*
proc plGetLib
*
para inLib

priv all like l_*

inLib = upper(inLib)
l_libs = set("library")

if !inLib $ l_libs
	**** the library of interest is not loaded.
	return ""
endif

l_numlibs = occur(",", l_libs) + 1
if l_numlibs = 1
	**** there is only one library loaded, this must be it
	return l_libs
endif

**** find the logical position the library of interest is in.
l_pos = occur(",", left(l_libs, at(inLib, l_libs))) + 1

do case
	case l_pos = l_numlibs
		**** it is the last of more than one libraries
		return subs(l_libs, rat(",", l_libs) + 2)

	case l_pos = 1
		**** it is the first of more than one libraries
		return left(l_libs, at(",", l_libs) - 1)

	otherwise
		**** it is somewhere in the middle
		l_retval = subs(l_libs, at(", ", l_libs, l_pos - 1) + 2, ;
		                        at(", ", l_libs, l_pos)+1)

		l_retval = left(l_retval, at(",", l_retval) - 1)
		return l_retval
endcase
