#include <fcntl.h>
#include <stdio.h>
#include "contact.h"


#define SEEKAMOUNT	3377		/* internal structure of btree */
					/* do not modify this! */

contact C;				/* actual record */

/*
 * Sample C application to demonstrate accessing the Contact Plus 
 * datafiles.  This application expects the record number to be 
 * passed on the commandline.  It will seek to the proper record and
 * output the NAME/COMPANY of the contact.
 *
 */

main(int argc, char ** argv)
{
    FILE * fp;
    long offset, recno;

    if (argc != 2)
    {
        fprintf(stderr, "Usage: SAMPLE RECNO\n");
	fprintf(stderr, "Where RECNO is a Contact Plus 2.3 record number\n\n");
	fprintf(stderr, "Example: SAMPLE 45\n");
	exit(1);
    }

    if ((fp = fopen("contact.dt", "rb")) == NULL)
    {
	fprintf(stderr, "\nERROR: Could not open CONTACT.DT\n");
	exit(1);
    }

    recno = atol(argv[1]);		/* get record number from cmnd line */

    					/* seek to proper record number */
    offset = SEEKAMOUNT + (recno - 1L) * sizeof(contact);

    if (fseek(fp, offset, 0) != 0)
    {
	fprintf(stderr, "\nERROR: Could not seek CONTACT.DT\n");
	exit(1);
    }

    if (fread((char *) &C, sizeof(contact), 1, fp) != 1)
    {
	fprintf(stderr, "\nERROR: Could not read CONTACT.DT\n");
	exit(1);
    }

    if (strncmp((char *) &C, "\033del\033", 5) == 0)
    {
        fprintf(stderr, "\nERROR: Contact record deleted\n");
    }
    else
    {
        printf("Contact name: %s %s\n", C.fname, C.lname);
        printf("Contact company: %s\n", C.company);
    }

    fclose(fp);
}
