* Use this skeleton to provide a safe way to edit fields without using static
* locks.  SYSRCHK will make sure that the record has not been changed by
* another user while the memvars are being edited.



* multiuser read/replace
m0noabort = .f.
m0abort = .f.
DO WHILE ! m0abort
	DO sysrchck WITH 1
	***** FIELDS -> MEMVARS ********
	mfield1 = field1
	.
	.
	.
	********************************

	******************************** READ DETAIL *********************************
	@ r,c SAY 'something' Get mfield1
	.
	.
	.
	******************************************************************************
	READ

	IF updated()
		IF ! sysrchck(2)
			********************************* REPLACES *******************************
			REPLACE NEXT 1 field1 WITH mfield1
			.
			.
			.
			**************************************************************************
			EXIT
		ENDIF
	ELSE
		EXIT
	ENDIF
ENDDO






******************************************************************************
* Description: Test for concurrent record editing
*
*						Parameters
*								1) To save original record for subsequent test
*								2) To test current record against original and prompt user
*									 if there is a problem
*								3) Same as 2 but without prompt
*
*						Returns
*								.f. if record has been changed while editing memvars
*								.t. if nothing has changed
*
*
******************************************************************************
PROCEDURE sysrchck
	PARAMETER option
	PRIVATE i, changed, pause, scrnbuff, fldmsg
	dirty = .f.

	* macros, might want to make these publics instead
	m0reverse = 'SET COLOR TO N/W'
	m0normal  = 'SET COLOR TO W/N'
	m0intense = 'SET COLOR TO +W/N'
	m0error   = 'SET COLOR TO +W/N'
	m0curson =	'?? sys(2002,1)'
	m0cursoff = '?? sys(2002)'

	IF option = 1
		* save original record
		SKIP	 		&& force a re-read
		SKIP -1
		RELEASE orig_rec
		PUBLIC orig_rec(fcount())
		SCATTER TO orig_rec
	ELSE
		* save current record
		SKIP	 		&& force a re-read
		SKIP -1
		DIMENSION cur_rec(fcount())
		SCATTER TO cur_rec
		* compare current record with saved original
		dirty = .f.
		i = 1
		DO WHILE i <= fcount()
			IF cur_rec(i) <> orig_rec(i)
				dirty = .t.
				EXIT
			ENDIF
			i = i + 1
		ENDDO
		RELEASE orig_rec
		RELEASE cur_rec
		IF dirty .and. option = 2
			SAVE SCREEN TO scrnbuff
			?? chr(7)
			fldmsg = 'Field: ' + field(i)
			&m0reverse
			@ 0,0
			@ 0,40 - (len(fldmsg)/2) SAY fldmsg
			@ 24,0
			@ 24,15 SAY 'Record was changed by another user, please re-edit.'
			pause = inkey(10)
			RESTORE SCREEN FROM scrnbuff
			&m0normal
		ENDIF
	ENDIF
RETURN dirty
* end of record change testor ************************************************




